<?
/*
 Network Interface Statistics Collection Agent v2.5
 by Brett Baugh

 This page saves your changes to the "config" table in the database.
 */
require_once("/etc/nisca/nisca.conf");
require_once($location["security"]);

if (preg_match('/[^\d]/', $f_delay) || $f_delay<1) {
  $f_delay=urlencode($f_delay);
  header("Location: adm_globals1.php?msg=baddelay&d=$f_delay");
  die;
}

$tmp=array("f_g_bg", "f_g_text", "f_g_lborder", "f_g_dborder", "f_g_peak", "f_g_in", "f_g_out");
foreach ($tmp as $t) {
  $$t=strtoupper($$t);
  $t2=$$t;
  if (preg_match('/[^\dA-F]/', $t2)) {
    $t2=urlencode($t2);
    header("Location: adm_globals1.php?msg=badcolor&color=$t2");
    die;
  }
}

if ($f_statsfile != "" && ! file_exists($f_statsfile)) {
  $t=urlencode($f_statsfile);
  header("Location: adm_globals1.php?msg=badstats&file=$t");
  die;
}

if ($f_ttf_font != "" && ! file_exists($f_ttf_font)) {
  $t=urlencode($f_ttf_font);
  header("Location: adm_globals1.php?msg=badfont&file=$t");
  die;
}

if (preg_match('/[^\d]/', $f_x)) {
  $bx=urlencode($f_x);
  header("Location: adm_globals1.php?msg=badx&bx=$bx");
  die;
}

if (preg_match('/[^\d]/', $f_y)) {
  $by=urlencode($f_y);
  header("Location: adm_globals1.php?msg=bady&by=$by");
  die;
}

if (trim($f_dateformat)=="" || trim($f_dformat)=="" || trim($f_tformat)=="") {
  header("Location: adm_globals1.php?msg=baddate");
  die;
}

// Now that we know nothing's wrong with the new config...
$sq="delete from config";
$res=dosql($sq);

// if ($f_have_gd=="n") { $f_have_gd=""; } else { $f_have_gd="y"; }
$f_have_gd="y";
if ($f_js_list=="n") { $f_js_list=""; } else { $f_js_list="y"; }
if ($f_X=="") { $f_X=700; }
if ($f_Y=="") { $f_Y=250; }

$sq="insert into config values('$version', $f_delay, '$f_have_gd', '$f_ttf_font', " .
    "$f_X, $f_Y, '$f_g_bg', '$f_g_text', '$f_g_lborder', '$f_g_dborder', '$f_g_peak', " .
    "'$f_g_in', '$f_g_out', '$f_statsfile', '$f_js_list', '$f_dateformat', " .
    "'$f_dformat', '$f_tformat', '$f_bitbyte', '$f_mailto', '$f_collect_cmd', " .
    "'$f_snmp_cmd', '$f_ps_cmd', '$f_graph_fmt')";
$res=dosql($sq);
header("Location: {$location["admin"]}/?msg=success");
?>
