<?
/*
 Network Interface Statistics Collection Agent v2.5
 by Brett Baugh

 This is where you select the interfaces to be monitored
 on localhost, via the /proc/net/dev file... not SNMP.
 */

require_once("/etc/nisca/nisca.conf");
require_once($location["security"]);
?>
<html><head>
<title>Network Interface Statistics Collection Agent -  Localhost Interface Administration</title>
<style type="text/css">
* { font-family: <? echo $fontface; ?>; }
</style>
</head>
<?
echo default_body() . titlebar("Localhost Interfaces Administration");
$helpname="local_if"; require_once($location["help"]);
echo "<hr size=1 noshade>\n";
if ($msg=="success") {
  echo "<P><font color=#228822><B>Operation completed successfully.</B></font><BR>\n";
  echo "<a href=\"{$location["admin"]}/\">Administration Menu</a></P>\n";
  echo "<hr noshade size=1>\n";
}
if ($msg=="aborted") {
  echo "<P><B>Operation aborted.</B></P>\n<hr noshade size=1>\n";
}
if ($msg=="duphost") {
  print_error("You entered a duplicate hostname (\"$h\").");
  echo "<hr noshade size=1>\n";
}
if ($msg=="blanksnmp") {
  print_error("You left all interfaces blank. This is just like deleting $host. Click on the \"Del\" button next to $host below if that's what you want to do.");
  echo "<hr noshade size=1>\n";
}
?>
<P>
<form method=POST action="adm_local2.php">

<table border=1 cellspacing=0 cellpadding=4>
<tr><td colspan=4 align=left><I>Select Interfaces on &quot;<? echo $local_hostname; ?>&quot; to be Monitored:</I></td></tr>
<tr><td>&nbsp;</td><th align=left>Interface Name</th><th>Alias</th><th>Speed</th></tr>
<?
$oldiflist=$newiflist=array();

// Populate $newiflist.
if (! $all=@file($statsfile)) {
  echo "<tr><td colspan=4>No interfaces available; the proc file \"$statsfile\" doesn't exist.<BR>\n" .
       "I can't do anything without it. The location of this file is configured<BR>\n" .
       "<a href=\"{$location["admin"]}/adm_globals1.php\">on this page</a> (second option).\n" .
       "</td></tr>\n</table>\n</body></html>";
  die;
} else {
  foreach($all as $line) {
    if(preg_match('/\s*(\S+)\s*:/', $line, $regs)) {
      $newiflist[]=$regs[1];
    }
  }
}

// Populate $oldiflist.
if (is_array($local_interfaces) && count($local_interfaces) > 0) {
  foreach($local_interfaces as $i) {
    $oldiflist[]=$i;
  }
}

$i=0;
if (is_array($newiflist) && count($newiflist) > 0) {
  foreach ($newiflist as $if) {
    $checked="";
    if (in_array($if, $oldiflist)) {
      $checked=" checked";
    }
    echo "<tr>\n";
    echo "<td align=center><input type=checkbox name=\"do$i\" value=\"$if\"$checked></td>\n";
    echo "<td>$if</td>\n";
    echo "<td><input type=text name=\"alias$i\" size=30 value=\"{$local_aliases[$if]}\"></td>\n";
    echo "<td><input type=text name=\"speed$i\" size=15 value=\""; 
    if ($local_speed[$if] > 0) {
      echo number_format($local_speed[$if]); 
    } 
    echo "\"></td>\n</tr>\n";
    $i++;
  }
  echo "<input type=hidden name=\"count\" value=\"$i\">\n";
  echo "<tr><td colspan=4 align=center><input type=submit value=\" Go \"></td></tr>\n";
} else {
  echo "<tr><th colspan=4>No interfaces available.</td></tr>\n";
}
?>
</table>
</form>
<hr noshade size=1>
<P>
<a href="<? echo $location["admin"]; ?>/">Administration Menu</a>
</P>
</body></html>
