<?
/*
 Network Interface Statistics Collection Agent v2.5
 by Brett Baugh

 This is where you select how you want to re-average values
 in the database.
 */

require_once("/etc/nisca/nisca.conf");
require_once($location["security"]);
?>
<html><head>
<title>Network Interface Statistics Collection Agent - Stats Re-Averaging Utility 1</title>
<style type="text/css">
* { font-family: <? echo $fontface; ?>; }
</style>
</head>
<?
echo default_body() . titlebar("Collected Stats Re-Averaging Utility");
$helpname="trim1"; require_once($location["help"]);
echo "<hr noshade size=1>\n";
if ($msg=="success") {
  echo "<P><font color=#228822><B>Re-Averaging Operation Completed Successfully.</B></font><BR>\n";
}
if ($msg=="aborted") {
  echo "<P><font color=#228822><B>Re-Averaging Operation Aborted.</B></font><BR>\n";
}
if ($msg=="bad") {
  print_error("You entered a bad time in the re-averaging time field. Please try again...");
}
echo "<a href=\"{$location["admin"]}/\">Administration Menu</a></P>\n";
echo "<hr noshade size=1>\n";
?>
<P>
This will re-average the stats from the database that match the criteria
you select here according to the time interval you specify.

<form method=POST action="adm_trim2.php" name="thisForm">
<input type=checkbox name="archive" checked> Leave this box checked to create an archived
backup of the removed data (it will be placed in the "<tt><? echo $location["archive"]; ?>"</tt> 
directory with a filename similar to "<tt>AVERAGED_06May2001-02.50.58.sql.gz</tt>").
If this box is UNchecked, all removed statistics will be permanently gone, as in "forever."
<P>
<table border=1 cellspacing=0 cellpadding=4>
<tr><td colspan=2 align=center><I>Select the Hostname/Community/Interface to be re-averaged:</I><BR>
</td></tr>
<?
$sq="select distinct hostname, community, if_name from stats_ifs order by hostname, community, if_name";
$res=dosql($sq);
if (mysql_num_rows($res) < 1) {
  echo "</table></form>\n<P>There are no stats in the database...</P>\n" .
       "<a href=\"{$location["admin"]}/\">Administration Menu</a>\n</body></html>";
  die;
}
$tmph=$tmpc="not possibly existent";
$j=0;
while ($row=mysql_fetch_array($res)) {
  $h=ss($row["hostname"]);
  $c=ss($row["community"]);
  $i=ss($row["if_name"]);
  if ($h != $tmph) {
    $tmph=$h;
    $tmpc=$c;
    if ($c=="") { $disp_c="Statsfile: \"$statsfile\""; } else { $disp_c="Community: \"$c\""; }
    echo "<tr><td bgcolor=#FFFF66 colspan=2 align=left><B>Host: \"$h\"<BR>$disp_c</B></td></tr>\n";
  } elseif ($c != $tmpc) {
    $tmpc=$c;
    if ($c=="") { $disp_c="Statsfile: \"$statsfile\""; } else { $disp_c="Community: \"$c\""; }
    echo "<tr><td bgcolor=#FFFF66 colspan=2 align=left><B>Host: \"$h\"<BR>$disp_c</B></td></tr>\n";
  }
  echo "<input type=hidden name=\"if_id$j\" value=\"{$if_id[$h][$c][$i]}\">\n";
  echo "<tr><td><input type=radio name=\"do\" value=\"$j\"></td>\n";
  echo "<td align=left>$h-&gt;$c-&gt;$i</td></tr>\n";
  $j++;
}
echo "<input type=hidden name=\"count\" value=\"$j\">\n";
?>
</table>
<hr size=1 noshade>
<P>
<table border=0 cellpadding=0>
<tr><td align=center colspan=3>
Enter the timeframe containing the entries to re-average. If nothing is entered here,<BR>
<B>everything</B> will be matched for re-averaging on the selected host/community/interface!
</td></tr>
<tr><td colspan=3 bgcolor=#000000><img src="1x1.gif" height=1></td></tr>
<tr><td align=center>
<table border=0 cellpadding=0>
<tr><td align=center colspan=6><B><I>From:</I></B></td></tr>
<tr>
<td align=center>Month</td>
<td align=center>Day</td>
<td align=center>Year</td>
<td align=center>Hour</td>
<td align=center>Min</td>
<td align=center>Sec</td>
</tr>
<tr><td align=center><select name="f_month">
<option value="">Month</option>
<option value="1">Jan</option>
<option value="2">Feb</option>
<option value="3">Mar</option>
<option value="4">Apr</option>
<option value="5">May</option>
<option value="6">Jun</option>
<option value="7">Jul</option>
<option value="8">Aug</option>
<option value="9">Sep</option>
<option value="10">Oct</option>
<option value="11">Nov</option>
<option value="12">Dec</option>
</select></td>
<td align=center><input type=text name="f_day" size=2 maxlength=2></td> 
<td align=center><input type=text name="f_year" size=4 maxlength=4></td> 
<td align=center><input type=text name="f_hour" size=2 maxlength=2></td> 
<td align=center><input type=text name="f_min" size=2 maxlength=2></td> 
<td align=center><input type=text name="f_sec" size=2 maxlength=2></td> 
</tr>
</table>
</td>
<td bgcolor=#000000><img src="1x1.gif" width=1></td>
<td align=center>
<table border=0 cellpadding=0>
<tr><td align=center colspan=6><B><I>To:</I></B></td></tr>
<tr>
<td align=center>Month</td>
<td align=center>Day</td>
<td align=center>Year</td>
<td align=center>Hour</td>
<td align=center>Min</td>
<td align=center>Sec</td>
</tr>
<tr><td align=center><select name="t_month">
<option value="">Month</option>
<option value="1">Jan</option>
<option value="2">Feb</option>
<option value="3">Mar</option>
<option value="4">Apr</option>
<option value="5">May</option>
<option value="6">Jun</option>
<option value="7">Jul</option>
<option value="8">Aug</option>
<option value="9">Sep</option>
<option value="10">Oct</option>
<option value="11">Nov</option>
<option value="12">Dec</option>
</select></td>
<td align=center><input type=text name="t_day" size=2 maxlength=2></td> 
<td align=center><input type=text name="t_year" size=4 maxlength=4></td> 
<td align=center><input type=text name="t_hour" size=2 maxlength=2></td> 
<td align=center><input type=text name="t_min" size=2 maxlength=2></td> 
<td align=center><input type=text name="t_sec" size=2 maxlength=2></td> 
</tr>
</table>
</td></tr>
</table>
<hr noshade size=1>
<P>
Enter the amount of time you want to re-average the values to:<BR>
<input type=text size=5 name="avgtime" value="5">
<select name="avgtype">
<option value="1">seconds</option>
<option value="60" selected>minutes</option>
<option value="3600">hours</option>
<option value="86400">days</option>
</select>
</P>
<hr noshade size=1>
<input type=submit value=" Go ">
</form>
<P>
<a href="<? echo $location["admin"]; ?>/">Administration Menu</a>
</P>
</body></html>
