<?   
/*
 Network Interface Statistics Collection Agent v2.5
 by Brett Baugh

 This contains the functions which are used more than once.
 */

require_once("/etc/nisca/nisca.conf");
require_once($location["db_config"]);
if (isset($inhibit_html) && getenv('GATEWAY_INTERFACE')) {
// This shouldn't be possible. All non-HTML scripts don't HAVE an extension, so
// the only way they could be run by the web server is if... erm... I dunno.
// But the consequences of doing so are too great, so... Just In Case.
  echo "<html><head><title>ERROR!</title></head>\n" . default_body() .
    titlebar("ERROR!") . "<B>This script cannot be run from a browser. Sorry.</B>\n</body></html>";
  die;
}

$persistent_connection=mysql_pconnect($db_host, $db_user, $db_pass);
mysql_select_db($database, $persistent_connection);

$font="<font face=\"$fontface\">";
$font2="<font face=\"$fontface\" size=2>";
$font1="<font face=\"$fontface\" size=1>";
$have_gz=function_exists("gzopen");
$have_bz=function_exists("bzopen");

function default_body($add="") {
  global $location, $font;
  $out="<body background=\"{$location["background"]}\" " .
       "bgcolor=#dddddd text=#000088 link=#666600 vlink=#666600 alink=#cc0000";
  if (trim($add) != "") {
    $out .= " $add";
  }
  $out .= ">\n$font\n";
  return $out;
}

function titlebar($label="") {
  global $version, $font;
  if (trim($version)=="") { $version="2.5"; } // Good lord, what a hack.
  $out= "<center>\n<table border=3 cellpadding=5><tr><td bgcolor=#bbbbff align=center valign=middle>" .
        "$font\n<b>N</b>etwork <b>I</b>nterface <b>S</b>tatistics " .
        "<b>C</b>ollection <b>A</b>gent v$version</td></tr>\n";
  if (trim($label) != "") {
    $out .= "<tr><td bgcolor=#bbbbff align=center valign=middle>$font$label</td></tr>\n";
  }
  $out .= "</td></tr>\n</table>\n</center>\n";
  return $out;
}

function dosql($sq) {
// This executes the SQL query specified in $sq.
  global $persistent_connection;
//  echo "<h3>$sq</h3>\n";   
  $res=mysql_query($sq, $persistent_connection);
  if (mysql_error($persistent_connection) != "") {
    echo "<h3>SQL Query Failure!</h3>\n<I>" .
      mysql_error($persistent_connection) . ":</I><P>\n$sq<P>\n";
  }  
  return $res;
}

function ss($in) {
// Am I the only one who thinks "stripslashes" is just too much
// to type for such a simple function?  :)
  return stripslashes($in);
}

function qs($in) {
// "value" fields on forms need quotes around them. If the value *contains*
// a quote, it doesn't work right... so all quotes need converting to "&quot;".
  return preg_replace('/"/', '&quot;', $in);
}

function load_prefs() {
// This sets all three types of config variables
// (global, local IFs, SNMP IFs) from the database.
  load_globals();
  load_local_ifs();
  load_snmp_ifs();
}

function load_globals() {
// This sets the global config variables from the database.
  global $version, $delay, $have_gd, $ttf_font, $X, $Y,
         $graph_background, $graph_text, $graph_border_light,
         $graph_border_dark, $graph_peak_highlight, $graph_incoming_data,
         $graph_outgoing_data, $statsfile, $js_list, $dateformat,
         $dformat, $tformat, $bitbyte, $mailto, $collect_cmd,
         $snmp_cmd, $ps_cmd, $graph_fmt, $if_id, $id_if;
  $sq="select * from config";
  $res=dosql($sq);
  if (mysql_num_rows($res) > 0) {
    $row=mysql_fetch_row($res);
    for ($i=0; $i<count($row); $i++) {
      $row[$i]=ss($row[$i]);
    }
    list($version, $delay, $gdcrap, $ttf_font, $X, $Y,
       $graph_background, $graph_text, $graph_border_light,
       $graph_border_dark, $graph_peak_highlight, $graph_incoming_data,
       $graph_outgoing_data, $statsfile, $js_list, $dateformat,
       $dformat, $tformat, $bitbyte, $mailto, $collect_cmd,
       $snmp_cmd, $ps_cmd, $graph_fmt) = array_values($row);
  }
  $gtest=extension_loaded("gd");
  $jtest=function_exists("imagecreatefromjpeg");
  $ptest=function_exists("imagecreatefrompng");
  if (!$gtest || (!$jtest && !$ptest)) { $have_gd=""; } else { $have_gd="y"; }
  if (!function_exists("imagettftext")) { $ttf_font=""; }
  $if_id=$id_if=array();
  $sq="select * from stats_ifs";
  $res=dosql($sq);
  if (mysql_num_rows($res) > 0) {
    while($row=mysql_fetch_array($res)) {
      $id=$row["id"];
      $h=ss($row["hostname"]);
      $c=ss($row["community"]);
      $i=ss($row["if_name"]);
      $if_id[$h][$c][$i]=$id;
      $id_if[$id]=array("h"=>$h, "c"=>$c, "i"=>$i);
    }
  }
}

function load_local_ifs() {
// This sets the localhost interface options from the database.
  global $local_hostname, $local_interfaces, $local_aliases, $local_speed;
  $local_interfaces=$local_aliases=$local_speed=array();
  $sq="select * from localhost";
  $res=dosql($sq);
  if (mysql_num_rows($res) > 0) {
    while ($row=mysql_fetch_array($res)) {
      $local_hostname=ss($row["hostname"]);
      $if=ss($row["if_name"]);
      $local_interfaces[]=$if;
      $local_aliases[$if]=ss($row["alias"]);
      if ($row["speed"] > 0) {
        $local_speed[$if]=$row["speed"];
      }
    }
  }
}

function load_snmp_ifs() {
// This sets the SNMP host/interface options from the database.
  global $hostname, $interfaces;
  $sq="select * from interfaces order by hostname, community, if_name";
  $res=dosql($sq);
  if (mysql_num_rows($res) > 0) {
    $hostnametmp=$interfacestmp=array();
    $thishost="";
    while ($row=mysql_fetch_array($res)) {
      if ($thishost != ss($row["hostname"])) {
        $thishost=ss($row["hostname"]);
        $hostnametmp[]=$thishost;
        $interfacestmp[$thishost]=array();
      }
      $interfacestmp[$thishost][]=array(
        "if_name"   => ss($row["if_name"]),
        "community" => ss($row["community"]),
        "dynamic"   => $row["dynamic"],
        "snmpv2"    => $row["snmpv2"],
        "alias"     => ss($row["alias"]),
        "speed"     => $row["speed"],
        "hostalias" => ss($row["hostalias"]),
        "method"    => ss($row["method"]),
        "cir"       => $row["cir"]
      );
    }
  }
  if ($hostname != $hostnametmp || $interfaces != $interfacestmp) {
// Something is different now; return new arrays.
    $hostname=$hostnametmp;
    $interfaces=$interfacestmp;
    return -1;
  } else {
// Nothing changed; return nothing.
    return 0;
  }
}

function print_error($in) {
// Just to make sure all error messages look pretty much the same.
// This accepts all HTML markup, too...
  echo "<P><font color=#cc0000><B>Error:</B></font><BR>\n$in</P>\n";
}

function result_fix($val) {
// This works on strings AND each element of arrays; $val can be either.
//  $replacements=array('/^[^=]+=\s*/', '/"/');
  $tmp=$val;
  $replacements='/"/';
  return preg_replace($replacements, '', $tmp);
}

function get_interfaces($hostname, $comm_arr, $method) {
// This returns an array of arrays of IF names keyed on the communities in $comm_arr.
  $out=array();
  $oid=set_oids();
  $out["-msgs-"][0]="";
  foreach ($comm_arr as $c) {
    $c=trim($c);
    if ($a=mysnmpwalkoid($hostname, $c, $oid[$method], "", TRUE)) {
      $a=result_fix($a);
      $out[$c]=array();
      foreach($a as $tmp) {
        $out[$c][]=$tmp;
      }
    } else {
// Yes, I know this is a weird way to do this;
// it's done this way to make it scalable. For the future.
      $out["-msgs-"][0] .= "The host \"$hostname\" ignored SNMP queries to the \"$c\" community.<BR>\n";
    }
  }
  return $out;
}

function set_oids() {
// This returns a nice array containing all these neato pre-defined
// numeric OID values as well as all the custom user-defined ones.
  global $field_name, $odd_oids;
  static $o;
  $prefix0=".1.3.6.1.2.1.1";               // system.
  $prefix1=".1.3.6.1.2.1.2.2.1";           // interfaces.ifTable.ifEntry
  $prefix2=".1.3.6.1.2.1.31.1.1.1";        // ifMIB.ifMIBObjects.ifXTable.ifXEntry
  if (!$o || !$odd_oids) {
// Should be a tiny bit faster this way, since it gets called very often.
    $o=array();
    $o["System"]         = $prefix0;       // full system tree
    $o["ifEntry"]        = $prefix1;       // full ifEntry tree
    $o["ifXEntry"]       = $prefix2;       // full ifXEntry tree
    $o["sysDescr"]       = "$prefix0.1.0"; // system.sysDescr
    $o["sysUpTime"]      = "$prefix0.3.0"; // system.sysUpTime
    $o["sysContact"]     = "$prefix0.4.0"; // system.sysContact
    $o["sysName"]        = "$prefix0.5.0"; // system.sysName
    $o["sysLocation"]    = "$prefix0.6.0"; // system.sysLocation
    $o["ifIndex"]        = "$prefix1.1";   // ifIndex
    $o["ifDescr"]        = "$prefix1.2";   // ifDescr (long version)
    $o["ifPhysAddress"]  = "$prefix1.6";   // ifPhysAddress (MAC/Ethernet address)
    $o["Speed"]          = "$prefix1.5";   // ifSpeed (32 bit counter)
    $o["InDiscards"]     = "$prefix1.13";  // ifInDiscards (32 bit)
    $o["InErrors"]       = "$prefix1.14";  // ifInErrors (32 bit)
    $o["OutDiscards"]    = "$prefix1.19";  // ifOutDiscards (32 bit)
    $o["OutErrors"]      = "$prefix1.20";  // ifOutErrors (32 bit)
    $o["ifName"]         = "$prefix2.1";   // ifName (short version; v2c only)
    $o["Alias"]          = "$prefix2.18";  // ifAlias (v2c only)
    $o["HCInOctets"]     = "$prefix2.6";   // ifHCInOctets (64 bit)
    $o["HCInUcastPkts"]  = "$prefix2.7";   // ifHCInUcastPkts (64 bit)
    $o["HCOutOctets"]    = "$prefix2.10";  // ifHCOutOctets (64 bit)
    $o["HCOutUcastPkts"] = "$prefix2.11";  // ifHCOutUcastPkts (64 bit)
    $o["InOctets"]       = "$prefix1.10";  // ifInOctets (32 bit)
    $o["InUcastPkts"]    = "$prefix1.11";  // ifInUcastPkts (32 bit)
    $o["OutOctets"]      = "$prefix1.16";  // ifOutOctets (32 bit)
    $o["OutUcastPkts"]   = "$prefix1.17";  // ifOutUcastPkts (32 bit)
    $o["locDescr"]       = ".1.3.6.1.4.1.9.2.2.1.1.28";  // Cisco-specific ifDescr
    $o["CatalystPort"]   = ".1.3.6.1.4.1.9.5.1.4.1.1.4"; // Cisco Catalyst Port Name
    $odd_oids=array($o["locDescr"], $o["CatalystPort"]);
/**********************************************************************************
    All these arrays are yours, except $field_name. Attempt no hacking there.
    To put it bluntly, so there's no misunderstanding:
    DO NOT change the $field_name array. At all, ever, mean it, trust me, don't.
    Not only that but it must stay precisely as it is now, for all eternity.
    Get my meaning? Do you feel lucky, geek? Erm... sorry. Too much coffee.
 **********************************************************************************/
    $field_name=array(
            $o["InOctets"]=>"r_bytes",
          $o["HCInOctets"]=>"r_bytes",
         $o["InUcastPkts"]=>"r_packets",
       $o["HCInUcastPkts"]=>"r_packets",
            $o["InErrors"]=>"r_errors",
          $o["InDiscards"]=>"r_dropped",
           $o["OutOctets"]=>"t_bytes",
         $o["HCOutOctets"]=>"t_bytes",
        $o["OutUcastPkts"]=>"t_packets",
      $o["HCOutUcastPkts"]=>"t_packets",
           $o["OutErrors"]=>"t_errors",
         $o["OutDiscards"]=>"t_dropped"
    );
  }
  return $o;
}

function oid_suck($hay, $needle) {
// Finds all OIDs in $hay that start with $needle.
  $out=array();
  foreach(array_keys($hay) as $tmp) {
    if (strpos($tmp, $needle, 0) !== FALSE) {
      $out[$tmp]=$hay[$tmp];
    }
  }
  return result_fix($out);
}

function getmicrotime() {
// This just fixes that stupid microtime() function 
// that returns seconds and microseconds as 2 strings.
  $mtime=microtime();
  $mtime=explode(" ", $mtime); 
  $mtime=$mtime[1] + $mtime[0];
  return $mtime;
}

function check_64($h, $c, $i) {
// This returns "y" if the interface $i supports 64-bit counters.
// It returns "" if the interface does not support 64-bit counters.
// It caches the snmpwalk results (per community) for later reference.
// NOTE: $i is the interface INDEX NUMBER, not its name!
  static $v2cache;
  $o=set_oids();
  if (! isset($v2cache[$c])) {
    $v2cache[$c]=mysnmpwalkoid($h, $c, $o["HCInOctets"], "y", TRUE);
    $v2cache[$c]=array_merge($v2cache[$c], mysnmpwalkoid($h, $c, $o["HCOutOctets"], "y", TRUE));
  }
  $ii=$o["HCInOctets"] . ".$i";
  $oi=$o["HCOutOctets"] . ".$i";
  if (preg_match('/^\d+$/', trim($v2cache[$c][$ii])) ||
      preg_match('/^\d+$/', trim($v2cache[$c][$oi]))) {
    return "y";
  }
  return "";
}

function errlog($text) {
  global $dateformat;
  error_log(date($dateformat) . ": $text", 0);
}

function add_watermark($img) {
// This merges the watermark image, $location["wmimg"], onto the graph image.
// Yes, I know about ImageCopyMerge() (see the "icm()" function below),
// but it didn't exist until PHP 4.0.6 so I wrote my own. :)
// If you don't have the ImageCopyMerge() function because your PHP is older,
// this function will automatically be used instead of icm() when making graphs.
  global $location;
  $wmimg=$location["wmimg"];
  if (trim($wmimg)=="") { return $img; }

// Some constants.
  $pct=30;   // the max color index value to modify by; 0-255.
  $border=2; // margin around watermark in pixels.

// Get the various sizes of everything.
  list($wm_x, $wm_y, $wmtype, $crap)=getimagesize($wmimg);
  $img_x=imagesx($img);
  $img_y=imagesy($img);
  $start_x=$img_x-($wm_x+$border);
  $start_y=$border;

// Read the watermark itself into a buffer; remember libgd can't do GIFs...
  switch($wmtype) {
  case 2:
    $buf_wm=imagecreatefromjpeg($wmimg);
    break;
  case 3:
    $buf_wm=imagecreatefrompng($wmimg);
    break;
  case 6:
    $buf_wm=imagecreatefromwbmp($wmimg);
    break;
  default:
// Unsupported watermark image format... :(
    return $img;
    break;
  }

// Use the average RGB value of each pixel in the watermark to lighten
// the corresponding pixel in the image:
  for ($y = $start_y; $y < ($wm_y+$start_y); $y++) {
    for ($x = $start_x; $x < ($wm_x+$start_x); $x++) {
// Get pixel pair colors from original image and watermark image.
      $pixel1=imagecolorsforindex($img, imagecolorat($img, $x, $y));
      $pixel2=imagecolorsforindex($buf_wm, imagecolorat($buf_wm, $x-$start_x, $y-$start_y));
      $r1=$pixel1["red"];
      $g1=$pixel1["green"];
      $b1=$pixel1["blue"];
      $r2=$pixel2["red"];
      $g2=$pixel2["green"];
      $b2=$pixel2["blue"];
// $wmval is the amount and direction to change the original pixel.
      $wmtmp=($r2+$g2+$b2)/3; // average (greyscaled watermark value)
      $wmtmp /= 255;          // percentage (color value)
// If original pixel is dark, make it lighter; if light, make it darker.
      if ($r1>127 || $g1>127 || $b1>127) {
        $wmval=(1-$wmtmp);      // darker
        $adj = -1;
        $pcttmp=255-$pct;
      } else {
        $wmval=(1+$wmtmp);      // lighter
        $adj = 1;
        $pcttmp=$pct;
      }
      $tmp=$wmtmp*$pcttmp;  // color value to add/subtract from this pixel
      $r3=$r1*$wmval + $tmp;
      $g3=$g1*$wmval + $tmp;
      $b3=$b1*$wmval + $tmp;
// Force all values between 0 and 255.
      if ($r3>255) { $r3=255; }
      if ($g3>255) { $g3=255; }
      if ($b3>255) { $b3=255; }
      if ($r3<0)   { $r3=0;   }
      if ($g3<0)   { $g3=0;   }
      if ($b3<0)   { $b3=0;   }
// If the new color is in the palette, use it; otherwise, add a new color.
      $color=imagecolorexact($img, $r3, $g3, $b3);
      if ($color==-1) { $color=imagecolorallocate($img, $r3, $g3, $b3); }
// Set the new color for this pixel.
      imagesetpixel($img, $x, $y, $color);
    }
  }
  return $img;
}

function icm($img) {
// An add_watermark() equivalent, using the ImageCopyMerge() function instead.
  global $location;
  $wmimg=$location["wmimg"];
  if (trim($wmimg)=="") { return $img; }

// Some constants.
  $pct=20;   // the percentage of "transparency" for the watermark; 0-100
  $border=2; // margin around watermark in pixels.

// Get the various sizes of everything.
  list($wm_x, $wm_y, $wmtype, $crap)=getimagesize($wmimg);
  $img_x=imagesx($img);
  $img_y=imagesy($img);
  $start_x=$img_x-($wm_x+$border);
  $start_y=$border;

// Read the watermark itself into a buffer; remember libgd can't do GIFs...
  switch($wmtype) {
  case 2:
    $buf_wm=imagecreatefromjpeg($wmimg);
    break;
  case 3:
    $buf_wm=imagecreatefrompng($wmimg);
    break;
  case 6:
    $buf_wm=imagecreatefromwbmp($wmimg);
    break;
  default:
// Unsupported watermark image format... :(
    return $img;
    break;
  }

  imagecopymerge($img, $buf_wm, $start_x, $start_y, 0, 0, $wm_x, $wm_y, $pct);
  return $img;
}

function formattime($secs) {
// This function... well, it should be obvious. :)
  if ($secs < 1) {
    $out=number_format($secs*1000, 4) . " milliseconds";
  } else {
    $tmp=$secs;
    $years = floor($tmp/31557600);
    $tmp -= ($years*31557600);
    $days = floor($tmp/86400);
    $tmp -= ($days*86400);
    $hours = floor($tmp/3600);
    $tmp -= ($hours*3600);
    $minutes = floor($tmp/60);
    $tmp -= ($minutes*60);
    $seconds = $tmp;
    $out = number_format($seconds, 3) . " secs";
    if ($minutes>0) { $out = "$minutes mins, " . $out; }
    if ($hours>0)   { $out = "$hours hrs, " . $out; }
    if ($days>0)    { $out = "$days days, " . $out; }
    if ($years>0)   { $out = number_format($years) . " years, " . $out; }
  }
  return $out;
}

function longformat($secs) {
  $days = floor($secs/86400);
  $secs -= ($days*86400);
  $hours = floor($secs/3600);
  $secs -= ($hours*3600);
  $minutes = floor($secs/60);
  $secs -= ($minutes*60);
  $seconds = $secs;
  if (strlen($seconds)<2) { $seconds="0$seconds"; }
  if (strlen($minutes)<2) { $minutes="0$minutes"; }
  if (strlen($hours)<2) { $hours="0$hours"; }
  $out = "$hours:$minutes:$seconds";
  if ($days>0) { $out = "$days d, " . $out; }
  return $out;
}

function php_ver_at_least($v) {
// This is an implementation of "version_compare()", which didn't exist until 4.1.0.
// It isn't used anywhere yet. Thanks go to "JoeDoeXP". :)
  $min = explode(".", $v);
  $cur = explode(".", phpversion());
  if (($cur[0] < $min[0])
      || (($cur[0] = $min[0]) && ($cur[1] < $min[1]))
      || (($cur[0] = $min[0]) && ($cur[1] = $min[1]) && ($cur[2][0] < $min[2][0]))) {
    return false;
  } else {
    return true;
  }
}

function dbstats() {
  global $db_stats, $database;
  if ($db_stats=="") { return; }
  $sq="show table status from $database";
  $res=dosql($sq);
  if (mysql_num_rows($res) < 1) { return; }
  $total=0;
  while ($row=mysql_fetch_array($res)) {
    $total += ($row["Data_length"] + $row["Index_length"]);
    if ($row["Name"] == "stats") {
      $free = $row["Max_data_length"];
      if ($free==0) {
        if (preg_match('/innodb free:\s*(\d+)/i', $row["Comment"], $regs)) {
          $free=$regs[1]*1024; // it SEEMS to always return this in kBytes...
        } // else, there really IS no free space...!
      }
      $rows = $row["Rows"];
      $i_stats = $row["Index_length"];
    }
  }
  $free -= $total;
  $out=
       "<I>Your database consumes " . number_format($total) . " bytes of disk space.<BR>\n" .
       "There are " . number_format($rows) . " rows in your \"stats\" table.<BR>\n" .
       "The \"stats\" table indexes consume " . number_format($i_stats) . " bytes.<BR>\n" .
       "I estimate you have " . number_format($free) . " bytes free now.</I><P>\n";
  return $out;
}

function mysnmpwalkoid($host, $comm, $oid, $v, $assoc=FALSE) {
  global $location, $debug;
  if ($v != "") { $cmd=$location["bin_snmpbulkwalk"] . " -v2c"; }
  else { $cmd=$location["bin_snmpwalk"] . " -v1"; }
  switch(strtolower($location["SnmpType"])) {
  case 4:
  case "ucd":
  case "ucd-snmp":
    $cmd.=" \"$host\" \"$comm\" $oid 2>&1";
    break;
  case 5:
  case "net":
  case "net-snmp":
    $cmd.=" -c \"$comm\" \"$host\" $oid 2>&1";
    break;
  default:
    echo "ERROR: You have to set \$location[\"SnmpVer\"] to 4 or 5 in nisca.conf!";
    return FALSE;
    break;
  }
  if ($debug) { echo "  \"$cmd\"\n"; }
  unset($result);
  exec($cmd, $result, $ret);
  if ($debug) { echo "    Command returned \"$ret\"\n"; }
  if (count($result) < 1 || $ret > 0) { return FALSE; }
  if ($assoc) {
    $tmp=array();
    foreach($result as $line) {
      preg_match('/^(\S+)\s+(.+)$/', $line, $regs);
      if ($regs[1]=="") { continue; }
      $tmp[$regs[1]]=$regs[2];
    }
    return $tmp;
  }
  return $result;
}

function orphaned_hosts() {
// Returns list of hosts that aren't being monitored anymore but have
// collected stats in the database.
  global $hostname;
  $out=array();
  $sq="select distinct hostname from stats_ifs order by hostname, community, if_name";
  $res=dosql($sq);
  if (mysql_num_rows($res) < 1) { return $out; }
  while ($row=mysql_fetch_array($res)) {
    if (in_array($row["hostname"], $hostname)) { continue; }
    $out[$row["hostname"]]=$row["hostname"];
  }
  return $out;
}

function make_select($name, $input, $default=FALSE, $blank=FALSE, $submit=FALSE, $script=FALSE, $class=FALSE) {
    if (!is_array($input) || count($input)<1) { return FALSE; }
    $out="<select ";
    if (trim($class)!="") { $out .= "class=\"$class\" "; }
    $out .= "name=\"$name\"";
    if ($submit) { $out .= " onChange='submit();'"; }
    elseif ($script !== FALSE) { $out .= " $script"; }
    $out .= ">\n";
    if ($blank!==FALSE) {
        $out .= "<option value=\"\">--Select $blank--</option>\n";
    }
    foreach(array_keys($input) as $id) {
        $out .= "<option value=\"$id\"";
            if ($default!==FALSE && $default==$id) { $out .= " selected"; }
            $out .= ">{$input[$id]}</option>\n";
    }
    $out .= "</select>\n";
    return $out;
}

// Load up the configuration variables from the database if they're needed.
if (! isset($skip_load)) { load_prefs(); }
?>
