<?
/*
 Network Interface Statistics Collection Agent v2.5
 by Brett Baugh

 Finalizes stats deletion requests.
*/
require_once("/etc/nisca/nisca.conf");
require_once($location["security"]);
if ($sql_query == "" || $idlist=="" || f_stamp=="" || t_stamp=="") {
  header("Location: adm_delstats1.php");
  die;
}
$ifidlist=preg_split('/,/', $idlist);
$dateformat=ereg_replace('y', 'Y', $dateformat);
if (trim($archive) != "") {
// Yes, I'm sorry I have to ignore whatever date/time format you have set, but
// we just can't have slashes in a filename now can we... I have to be sure.
// This format should be recognizeable by everyone though... and the month name
// will be in whatever language you're using :)
  $filename="{$location["archive"]}/DELETED_" . date("dMY-H.i.s") . ".sql";
  if ($have_gz) {
    $openfunc="gzopen"; $putfunc="gzwrite"; $closefunc="gzclose";
    $filename .= ".gz";
  } elseif ($have_bz) {
    $openfunc="bzopen"; $putfunc="bzwrite"; $closefunc="bzclose";
    $filename .= ".bz2";
  } else {
    $openfunc="fopen"; $putfunc="fwrite"; $closefunc="fclose";
  }
  if (! $fp=@$openfunc($filename, "w")) {
?>
<html>
<? echo default_body() . titlebar(); ?>
Couldn't write the backup file to "<? echo $filename; ?>"... aborting.<BR>
Hit your "Back" button, check the permissions on that directory, and try again...
because it's either that, or your PHP doesn't have the zlib in it. If you don't have
zlib support in your PHP installation, you can always turn off the backup feature
on the previous screen.
<P>
<a href="adm_delstats1.php">Stats Deletion Menu</a>
</body></html>
<?
    die;
  }
  $out=
'# NISCA 2.2 Deleted Stats Archive File
# Dump created on ' . date($dateformat) . '
# To restore this file, run this command:
';
  switch ($openfunc) {
  case "gzopen":
    $out .= "#    zcat $filename | mysql $database\n";
    break;
  case "bzopen":
    $out .= "#    bzcat $filename | mysql $database\n";
    break;
  default:
    $out .= "#    cat $filename | mysql $database\n";
    break;
  }
  $out .= '# This file contains data for:
';

  foreach ($ifidlist as $id) {
    if (trim($id)=="") { continue; }
    $out .= 
'# ----------------------------
#          host: ' . $id_if[$id]["h"] . '
#     community: ' . $id_if[$id]["c"] . '
#     interface: ' . $id_if[$id]["i"] . '
#         if_id: ' . $id . '
';
    }

  $out .=
'# ----------------------------
#          from: ' . date($dateformat, $f_stamp) . '
#            to: ' . date($dateformat, $t_stamp) . '
#      interval: EVERYTHING (1 second :)
#
';
  $sql2=ereg_replace("select stamp from", "select * from", ss($sql_query));
  $res=dosql($sql2);
  while($row=mysql_fetch_array($res)) {
    $out .= "REPLACE INTO stats (if_id, r_bytes, r_packets, r_errors, r_dropped, " .
      "t_bytes, t_packets, t_errors, t_dropped, stamp) VALUES ({$row["if_id"]}, {$row["r_bytes"]}, " .
      "{$row["r_packets"]}, {$row["r_errors"]}, {$row["r_dropped"]}, " .
      "{$row["t_bytes"]}, {$row["t_packets"]}, {$row["t_errors"]}, " .
      "{$row["t_dropped"]}, {$row["stamp"]});\n";
  }
  if (! preg_match('/ AND \(stamp/i', $sql_query)) {
    foreach($ifidlist as $id) {
      if (trim($id)=="") { continue; }
      $out .= "replace into stats_ifs (id, hostname, community, if_name) values (" .
        "$id, '{$id_if[$id]["h"]}', '{$id_if[$id]["c"]}', '{$id_if[$id]["i"]}');\n";
    }
  }
  if (! @$putfunc($fp, $out)) {
    echo "<html>" . default_body() . titlebar() .
      "\nError writing to $filename! I will not be removing any stats from your database.<BR>\n" .
      "<a href=\"adm_trim1.php\">Re-Averaging Menu</a>\n</body></html>";
// Might as well try to close it anyway at this point...
    @$closefunc($fp);
    die;
  }
  if (! @$closefunc($fp)) {
    echo "<html>" . default_body() . titlebar() .
      "\nError closing $filename! I will not be removing any stats from your database.<BR>\n" .
      "<a href=\"adm_trim1.php\">Re-Averaging Menu</a>\n</body></html>";
    die;
  }
}

$sql_query=ereg_replace("select stamp from", "delete from", ss($sql_query));
//echo "$sql_query<BR>\n";
$res=dosql($sql_query);
if (! preg_match('/ AND \(stamp/i', $sql_query)) {
  foreach($ifidlist as $id) {
    if (trim($id)=="") { continue; }
    $sq="delete from stats_ifs where id=$id";
    $res=dosql($sq);
//echo "$sq<BR>\n";
  }
}
header("Location: adm_delstats1.php?msg=success");
?>
