<?
/*
 Network Interface Statistics Collection Agent v2.5
 by Brett Baugh

 This confirms the stats to be re-averaged.
 */

require_once("/etc/nisca/nisca.conf");
require_once($location["security"]);
if (trim($count) == "" || $count < 1) {
  header("Location: adm_trim1.php");
  die;
}
if (preg_match('/[^\d\.]+/', $avgtime) || trim($avgtime)=="") {
  header("Location: adm_trim1.php?msg=bad");
  die;
}

$hdr="<html><head> 
<title>Network Interface Statistics Collection Agent - Stats Re-Averaging Utility 2</title>
<style type=\"text/css\">
* { font-family: $fontface; }
</style>
</head>" . default_body() . titlebar("Collected Stats Re-Averaging Utility") .
"<hr noshade size=1>\n";

if ($do=="") {
  echo "$hdr\nYou didn't select any interfaces to re-average stats for. " .
    "Please hit your \"Back\" button or the link below and try again.<P>\n" .
    "<B><a href=\"Javascript: history.back()\">Back</a></B>\n" .
    "</body></html>\n";
  die;
}

$interval=$avgtime*$avgtype;
$tmp="if_id$do";
$id=$$tmp;
$h=$id_if[$id]["h"];
$c=$id_if[$id]["c"];
$i=$id_if[$id]["i"];
$sq="select stamp from stats where (if_id=$id";
$iflist = "$h-&gt;$c-&gt;$i<BR>\n";

if ($f_month != "" || $t_month != "") {
  if ($f_month == "" || $f_day == "" || $f_year == "") {
    $f_month=$f_day=1;
    $f_year=1970;
    $f_hour=$f_min=$f_sec=0;
  } else {
    if ($f_day<1 || $f_day>31 || $f_year<1970 || $f_year>date("Y")) {
      echo "$hdr\nYou entered an invalid \"From\" date. Please hit your \"Back\" button " .
        "or the link below and try again.<P>\n" .
        "<B><a href=\"Javascript: history.back()\">Back</a></B>\n" .
        "</body></html>\n";
      die;
    }
    if ($f_hour=="" || $f_min=="" || $f_sec=="") {
      $f_hour=$f_min=$f_sec=0;
    } else {
      if ($f_hour<0 || $f_hour>23 || $f_min<0 || $f_min>59 || $f_sec<0 || $f_sec>59) {
        echo "$hdr\nYou entered invalid text in the \"From\" time. Please hit your \"Back\" button " .
          "or the link below and try again.<BR>\n" .
          "($f_hour:$f_min:$f_sec)<P>\n" .
          "<B><a href=\"Javascript: history.back()\">Back</a></B>\n" .
          "</body></html>\n";
        die;
      }
    }
  }
  if ($t_month == "" || $t_day == "" || $t_year == "") {
    $t_month=date("m");
    $t_day=date("d");
    $t_year=date("Y");
    $t_hour=date("H");
    $t_min=date("i");
    $t_sec=date("s");
  } else {
    if ($t_day<1 || $t_day>31 || $t_year<1970 || $t_year>date("Y")) {
      echo "$hdr\nYou entered an invalid \"From\" date. Please hit your \"Back\" button " .
        "or the link below and try again.<P>\n" .
        "<B><a href=\"Javascript: history.back()\">Back</a></B>\n" .
        "</body></html>\n";
      die;
    }
    if ($t_hour=="" || $t_min=="" || $t_sec=="") {
      $t_hour=23;
      $t_min=$t_sec=59;
    } else {
      if ($t_hour<0 || $t_hour>23 || $t_min<0 || $t_min>59 || $t_sec<0 || $t_sec>59) {
        echo "$hdr\nYou entered invalid text in the \"From\" time. Please hit your \"Back\" button " .
          "or the link below and try again.<BR>\n" .
          "($t_hour:$t_min:$t_sec)<P>\n" .
          "<B><a href=\"Javascript: history.back()\">Back</a></B>\n" .
          "</body></html>\n";
        die;
      }
    }
  }

  $f_stamp=mktime($f_hour, $f_min, $f_sec, $f_month, $f_day, $f_year);
  $t_stamp=mktime($t_hour, $t_min, $t_sec, $t_month, $t_day, $t_year);
  if ($f_stamp > $t_stamp) {
    echo "$hdr\nYou can't enter a From time that's later than the To time, you silly user. " .
      "Please hit your \"Back\" button or the link below and try again.<P>\n" .
      "<B><a href=\"Javascript: history.back()\">Back</a></B>\n" .
      "</body></html>\n";
    die;
  }
  $tmp=$t_stamp-$f_stamp;
  if ($tmp < $interval) {
    echo "$hdr\nYour specified interval time ($interval seconds) is greater than" .
      "the from/to range you entered ($tmp seconds). This is just silly.<BR>\n" .
      "Please hit your \"Back\" button or the link below and try again.<P>\n" .
      "<B><a href=\"Javascript: history.back()\">Back</a></B>\n" .
      "</body></html>\n";
    die;
  }
  $sq .= " AND (stamp >= $f_stamp AND stamp <= $t_stamp)) order by stamp";
} else {
  $sq .= ") order by stamp";
  $f_stamp=0;
// This is the highest value the 32-bit unix timestamp can hold.
  $t_stamp=0xFFFFFFFF;
}

$res=dosql($sq);
if (mysql_num_rows($res) < 1) {
  echo "$hdr\nNo statistics would be re-averaged given this request.\n" .
    "Please hit your \"Back\" button or the link below and try again.<P>\n" .
    "<B><a href=\"Javascript: history.back()\">Back</a></B>\n" .
    "</body></html>\n";
  die;
}
$totalnum=number_format(mysql_num_rows($res));

$num=0;
$ceil=mysql_result($res,0,"stamp") + $interval;
while($row=mysql_fetch_row($res)) {
  if ($row[0] > $ceil) {
// Leave this entry in; set new ceiling.
    $ceil = $row[0] + $interval;
  } else {
// Archive/delete this entry
    $num++;
  }
}

$num2=number_format($num);
$dateformat=ereg_replace('y', 'Y', $dateformat);

echo $hdr;

echo "<table border=0 cellpadding=0 cellspacing=4>\n" .
  "<tr><th colspan=2 align=left>Interface to be re-averaged:</th></tr>\n" .
  "<tr><td><img src=\"1x1.gif\" width=20></td><td>$iflist</td></tr>\n" .
  "<tr><td colspan=2 bgcolor=#000000><img src=\"1x1.gif\" height=1></td></tr>\n</table>\n";

echo "<table border=0 cellpadding=0 cellspacing=4>\n" .
  "<tr><th colspan=2 align=left>Averaging Interval</th></tr>\n" .
  "<tr><td><img src=\"1x1.gif\" width=20></td><td>$interval seconds</td></tr>\n" .
  "<tr><td colspan=2 bgcolor=#000000><img src=\"1x1.gif\" height=1></td></tr>\n</table>\n";

echo "<table border=0 cellpadding=0 cellspacing=4>\n";
if ($f_stamp != "") {
  echo "<tr><th colspan=3 align=left>From/To Times:</th></tr>\n" .
    "<tr><td><img src=\"1x1.gif\" width=20></td>" .
    "<td align=right><I>From:</I></td><td>" . date($dateformat, $f_stamp) . "</td></tr>\n" .
    "<tr><td><img src=\"1x1.gif\" width=20></td>" .
    "<td align=right><I>To:</I></td><td>" . date($dateformat, $t_stamp) . "</td></tr>\n" .
    "<tr><td colspan=3 bgcolor=#000000><img src=\"1x1.gif\" height=1></td></tr>\n";
} else {
  echo "<tr><th colspan=2 align=left>From/To Times:</th></tr>\n" .
    "<tr><td><img src=\"1x1.gif\" width=20></td>" .
    "<td><I>No range set; all entries selected!</I></td></tr>\n" .
    "<tr><td colspan=2 bgcolor=#000000><img src=\"1x1.gif\" height=1></td></tr>\n";
}
echo "</table>\n";
if ($num==0) {
  echo "<P>\n<B>No</B> entries (out of $totalnum) would be removed by this request.<BR>" .
    "No point in continuing, really.... :)</P>\n" .
    "<a href=\"adm_trim1.php\">Re-Averaging Menu</a><BR>\n" .
    "<a href=\"{$location["admin"]}/\">Administration Menu</a></P>\n</body></html>";
  die;
} else {
  $arch="and <B>NOT</B> archived ";
  if ($archive != "") { $arch="and archived "; }
  echo "<P>\n<B>Notice: $num2</B> entries (out of $totalnum) will be removed $arch by this request. Continue?<P>\n";
}
?>
<h1>
<form method=POST action="adm_trim3.php">
<input type=hidden name="archive" value="<? echo $archive; ?>">
<input type=hidden name="f_stamp" value="<? echo $f_stamp; ?>">
<input type=hidden name="t_stamp" value="<? echo $t_stamp; ?>">
<input type=hidden name="id" value="<? echo $id; ?>">
<input type=hidden name="interval" value="<? echo $interval; ?>">
<input type=hidden name="sql_query" value="<? echo $sq; ?>">
<input type=submit value=" YES! ">
</form>
<form method=POST action="adm_trim1.php">
<input type=hidden name=msg value="aborted">
<input type=submit value=" NO! ">
</form>
</h1>
</body></html>
