<?
/*
 Network Interface Statistics Collection Agent v2.5
 by Brett Baugh
*/
require_once("/etc/nisca/nisca.conf");
require_once($location["functions"]);
?>
<html><head>
<title>Network Interface Statistics Collection Agent</title>
<style type="text/css"><? echo "
*.g_bg      { color: #$graph_text; background-color: #$graph_background; }
*.g_text    { color: #$graph_text; background-color: #$graph_background; }
*.g_lborder { color: #$graph_border_light; background-color: #$graph_background; }
*.g_dborder { color: #$graph_border_dark; background-color: #$graph_background; }
*.g_peak    { color: #$graph_peak_highlight; background-color: #$graph_background; }
*.g_in      { color: #$graph_incoming_data; background-color: #$graph_background; }
*.g_out     { color: #$graph_outgoing_data; background-color: #$graph_background; }
*           { font-family: $fontface; }
</style>
";
?>
<script language="Javascript">

// Browser sniffer. 'incapable' must be global.
var agent=navigator.userAgent.toLowerCase();
var incapable=false;
if (agent.indexOf('mozilla/4') != -1 && agent.indexOf('msie') == -1) {
  incapable=true;
}

// Changes the appropriate colors in the CSS for the right elements as the values are changed.
function colorswitch(fld) {
  if(!document.styleSheets && document.getElementsByTagName) {
// Gotta make our own styleSheets array.
    document.styleSheets=[];
    document.styleSheets.concat(document.getElementsByTagName('STYLE'));
  }
  if(!document.styleSheets) {
// Incapable browser. Upgrade! :)
    return;
  }
  var col=eval("document.thisForm."+fld+".value");
  var flds=new Array("g_bg", "g_text","g_lborder","g_dborder","g_peak","g_in","g_out");
  var i, j, cls; 
  if(!document.styleSheets[0].cssRules) {
//IE Browser.
    cls=document.styleSheets[0].rules;
  } else {
// not IE.
    cls=document.styleSheets[0].cssRules;   
  }
  if (fld=="g_bg") {
// Change background color in all seven classes.
    for (i=0; i<flds.length; i++) {
      cls[i].style.backgroundColor=col;
    }
  } else {
    for (j=0; j<flds.length; j++) {
// Find the right class name.
      if (flds[j]==fld) { break; }
    }
// Change this class' text color.
    cls[j].style.color=col;
    if (fld=="g_text") {
// Also change the "Background" field's text display.
      cls[0].style.color=col;
    }
  }
}

function checkIt(e) {
  if (e.selectedIndex == 0) {
    return false;
  } else {
    document.thisForm.submit();
  }
}

<?
$sq="select distinct hostname, if_name from stats_ifs order by hostname, if_name";
// it's not really a bigres anymore... but.
$bigres=dosql($sq);
if ($js_list != "") {
?>
var i;
var hostif_array=new Array();
var host_array=new Array();
<?
// Build the Javascript commands that will create a 2-d array of
// all interface names on each host, ignoring the community.
// This should be replaced with just if_id's (ds_id's rather) by nisca 3.
if (mysql_num_rows($bigres) > 0) {
  $thishost=" not possibly existent "; // just "" isn't good enough here; hosts CAN be blank.
  while ($row=mysql_fetch_array($bigres)) {
    if ($thishost != ss($row["hostname"])) {
      $thishost=ss($row["hostname"]);
      $i=0;
      echo "host_array[host_array.length] = \"$thishost\";\n";
      echo "hostif_array[\"$thishost\"] = new Array();\n";
    }
    $h=ss($row["if_name"]);
    echo "hostif_array[\"$thishost\"][" . $i . "]=\"$h\";\n";
    $i++;
  }
  mysql_data_seek($bigres, 0);
}
?>

function change_if() {
// Change the list of interfaces based on which hostname is selected.
  var e=document.thisForm.plus_host;
  var hostname=e.options[e.selectedIndex].value;
  if (hostname==null || hostname=="") {
    document.thisForm.plus_if.length=0;
    document.thisForm.plus_if.options[0]=new Option("-- Select Interface--", "", false, false);
    return;
  }
  var fm=document.thisForm.plus_if;
  fm.options.length=0;
  fm.options[0]=new Option("-- Select Interface --", "", false, false);
  if (hostname==null || hostname=="") { return; }
  var hostarray=hostif_array[hostname];
  for (i=0; i<hostarray.length; i++) {
    fm.options[fm.options.length]=new Option(hostarray[i], hostarray[i], false, false);
  }
  return false;
}

function add_if() {
// When an interface is selected, add it to the multi-select box unless it already was.
// If all=='y', add every interface to the box that isn't there already.
// We CAN'T refer to the multi-select element by its name ("host_if[]")...
// It's the sixth element in the form, though.
  var outlist = document.thisForm.elements[5];
  var host=document.thisForm.plus_host.options[document.thisForm.plus_host.selectedIndex].value;
  var ifname=document.thisForm.plus_if.options[document.thisForm.plus_if.selectedIndex].value;
// whew.... Javascript has loooooong variable names.

  if (host==null || host=="" || ifname==null || ifname=="") { return; }
  var dup_entry=0;
  for (i=1; i<outlist.options.length; i++) {
    if (outlist.options[i].value == host + "!" + ifname) {
      dup_entry=1;
    }
  }
  if (dup_entry==0) {
    outlist.options[outlist.options.length]=new Option(host + "->" + ifname, host + "!" + ifname, true, true);
  }
  document.thisForm.plus_if.selectedIndex=-1;
  outlist.selectedIndex=-1;
  return false;
}

function add_all() {
// Add every interface to the multi-select box that isn't there already.
// We CAN'T refer to this element by its name ("host_if[]")...
// It's the sixth element in the form, though.
  var outlist = document.thisForm.elements[5];
  var host=document.thisForm.plus_host.options[document.thisForm.plus_host.selectedIndex].value;
  if (host==null || host=="") { return; }
  var iflist=document.thisForm.plus_if;
  var dup_entry, i, j;
  for (i=1; i<iflist.options.length; i++) {
    var ifname=iflist.options[i].value;
    dup_entry=0;
    for (j=1; j<outlist.options.length; j++) {
      if (outlist.options[j].value == host + "!" + ifname) {
        dup_entry=1;
      }
    }
    if (dup_entry==0) {
      outlist.options[outlist.options.length]=new Option(host + "->" + ifname, host + "!" + ifname, true, true);
    }
  }
  document.thisForm.plus_if.selectedIndex=-1;
  outlist.selectedIndex=-1;
  return false;
}

function clear_if() {
  var outlist = document.thisForm.elements[5];
  outlist.options.length=0;
  outlist.options[0] = new Option("      Hostname->Interface     ", "", false, false);
  return false;
}

function trim_if() {
// This function only seems to work right in I.E.; Netscape just crashes. Go figure.
  var outlist = document.thisForm.elements[5];
  var newout = new Array();
  newout[0] = new Option("      Hostname->Interface      ", "", false, false);
  for (i=1; i<outlist.options.length; i++) {
    if (outlist.options[i].selected==true) {
      newout[newout.length] = outlist.options[i];
    }
  }
  outlist.options.length=0;
// The first entry will always be the label.
  outlist[0] = new Option("      Hostname->Interface      ", "", false, false);
  for (i=1; i<newout.length; i++) {
    outlist.options[outlist.options.length]=new Option(newout[i].text, newout[i].value, true, true);
  }
  return false;
}

function setAll() {
  var outlist = document.thisForm.elements[5];
  if (outlist.options.length<2) {
    alert ('You must pick at least one Interface to report on.');
    return false;
  }
  for (i=1; i<outlist.options.length; i++) {
    outlist.options[i].selected=true;
  }
  return true;
}

<? } ?>
</script>
</head>
<?
echo default_body("onLoad='document.thisForm.report.selectedIndex=0; " .
                  "document.thisForm.rpt_name.value=\"\"; change_if();'") . titlebar();
$helpname="main"; require_once($location["help"]);
$sq="select MAX(stamp) as s_max, MIN(stamp) as s_min from stats";
$res=dosql($sq);
$row=mysql_fetch_array($res);
$min_stamp=$row["s_min"];
$max_stamp=$row["s_max"];
?>
<P>
<hr size=1 noshade>
<form action="report.php" method=POST name="thisForm" onSubmit="return setAll()">
<table border=0 cellpadding=0>
<tr>
<td align=left>
</td>
<td>
<select name="report" onChange="submit()">
<option value="">-- Select Stored Report --</option>
<?
$sq="select id, name from reports order by name";
$res=dosql($sq);
if (mysql_num_rows($res) > 0) {
  while ($row=mysql_fetch_array($res)) {
    echo "<option value=\"{$row['id']}\">" . ss($row['name']) . "</option>\n";
  }
}
echo "</select>\n";
?>
<input type=submit value=" Run It! ">
<BR>

<a href="<? echo $location["admin"]; ?>/">Click Here For NISCA Administration</a>
</td>
</tr>
</table>
<hr size=1 noshade>
<B>Report Data Configuration</B><P>
<table border=0 cellpadding=0>
<tr><td align=center valign=top colspan=2>
Select all the host/IFs you want stats on<BR>
<font size=1><a href="ranges1.php">(Most-Recent Collection Times)</a></font><BR>
<? if ($js_list != "") { ?>
<script language="Javascript">
//<!--
  document.write("<table border=0 cellpadding=0 cellspacing=3>\n"
    + "<tr><td align=center valign=bottom colspan=2>\n"
    + "<select name=\"plus_host\" onClick=\"change_if()\">\n"
    + "  <option value=\"\">-- Hostname --</option>\n");
  for (var i=0; i<host_array.length; i++) {
    document.write("  <option value=\"" + host_array[i] + "\">" + host_array[i] + "</option>\n");
  }
  document.write("</select></td></tr>\n");
  document.write("<tr><td align=center valign=top><select size=6 name=\"plus_if\" onChange=\"add_if()\">\n"
    + "  <option value=\"\">-- Select Interface --</option>\n</select><BR>\n"
    + "  <input type=button value=\"Add All\" onClick=\"add_all();\">"
    + "</td>\n");
  document.write("<td valign=top align=left><select multiple size=6 name=\"hostif[]\">\n"
    + "  <option value=\"\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Hostname->Interface&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</option>\n</select><BR>\n<center>\n");
  document.write("<input type=button value=\"Clear All\" onClick=\"clear_if();\">&nbsp;&nbsp;&nbsp;\n"
    + "<input type=button value=\"Clear Deselected\" onClick=\"trim_if();\"></td></tr>\n</table>\n");
// -->
</script>
<noscript>
<? }

$num_ifs=mysql_num_rows($bigres);
if ($num_ifs + count($hostname) >= 10) {
  $size=10;
} else {
  $size=$num_ifs+count($hostname)+1;
}

echo "<select multiple size=$size name=\"hostif[]\">\n";
$lasthost="";
while ($row=mysql_fetch_array($bigres)) {
  $h=ss($row["hostname"]);
  $i=ss($row["if_name"]);
  if ($lasthost=="") {
    echo "<optgroup label=\"$h\">\n";
    $lasthost=$h;
  }
  if ($lasthost != $h) {
    echo "</optgroup>\n<optgroup label=\"$h\">\n";
    $lasthost=$h;
  }
  echo "<option value=\"$h!$i\">$h -&gt; $i</option>\n";
}
mysql_free_result($bigres);
echo "</optgroup>\n</select>\n";
if ($js_list != "") { echo "</noscript>"; }
?>
</td>
<td bgcolor=#000000><img src="1x1.gif" width=1></td>
<td valign=top>
Show report(s) for the following types of information:<BR>
<table border=0 cellpadding=0>
<tr>
<td><input type=checkbox name="bytes" value="y" checked> Bytes transferred</td>
<td bgcolor=#000000 rowspan=2><img src="1x1.gif" border=0></td>
<td><input type=checkbox name="errors" value="y"> Transfer errors</td>
</tr>
<tr>
<td><input type=checkbox name="packets" value="y"> Packets transferred</td>
<td><input type=checkbox name="dropped" value="y"> Dropped packets</td>
</tr>
<?
if ($have_gd != "") {
  echo "<tr><td colspan=3>\n<input type=checkbox name=\"multiple\"> " .
       "Make \"multiple\" byte-count report<BR>\n&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;using a " .
       "<input type=text name=\"avginterval\" value=\"$delay\" size=8>-second interval.</td></tr>\n";
}
?>
<tr>
<td colspan=3 align=right>
<select name="reportctl">
<?
echo "<option value=\"r\">Show text report(s) only.</option>\n";
if ($have_gd != "") {
  echo "<option value=\"g\" selected>Show graph(s) only.</option>\n";
  echo "<option value=\"gr\">Show graph(s) and text report(s).</option>\n";
}
?>
</select><BR>
<select name="in_out">
<option value="io">Show Incoming &amp; Outgoing Data</option>
<option value="i">Show Incoming Data Only</option>
<option value="o">Show Outgoing Data Only</option>
</select><BR>
<select name="g_fmt">
<?
if ($have_gd != "") {
  if (imagetypes() & IMG_JPG) {
    echo "<option value=\"j\"";
    if ($graph_fmt=="j") { echo " selected"; }
    echo ">Make Graphs as JPGs</option>\n";
  }
  if (imagetypes() & IMG_PNG) {
    echo "<option value=\"p\"";
    if ($graph_fmt=="p") { echo " selected"; }
    echo ">Make Graphs as PNGs</option>\n";
  }
} else {
  echo "<option value=\"\">\"libgd\" support not present.</option>\n";
}
?>
</select><BR>
<select name="g_bb">
<option value="gr"<? if ($bitbyte=="B") { echo " selected"; } ?>>Graphs: bytes; Text: bytes</option>
<option value="r">Graphs: bits; Text: bytes</option>
<option value="g">Graphs: bytes; Text: bits</option>
<option value=""<? if ($bitbyte=="b") { echo " selected"; } ?>>Graphs: bits; Text: bits</option>
</select><BR>
<select name="do95">
<option value="0">Don't Use 95th Percentile</option>
<option value="1">Use 95th Percentile</option>
</select>
</td>
</tr>
</table>
</td></tr>
</table>
<hr size=1 noshade>
<B>Report Time Configuration</B><P>
Select how much data to view here. Set the value of &quot;<B>X</B>&quot; below to match
what you want if using one of the selections with an &quot;X&quot; in it.<BR>
<table border=0 cellpadding=0>
<tr><td align=center>
<select name="timeperiod">
<option value="">The entire contents of the database.</option>
<option value="last_day" selected>The past <I>X</I> days.</option>
<option value="last_hour">The past <I>X</I> hours.</option>
<option value="last_minute">The past <I>X</I> minutes.</option>
<option value="set_dates">A date/time range, set below.</option>
</select>
<B>X</B> = <input type=text name="time_x" value="1" size=5>
</td></tr>
</table>
<table border=0 cellpadding=0>
<tr><td colspan=3><I>(Dates below are pre-set to the earliest and latest values in the database for your convenience.<BR>
<a href="ranges1.php">Click here</a> for the time ranges on a per-host basis.)</I></td></tr>
<tr><td align=center>
<table border=0 cellpadding=0>
<tr><td align=center colspan=6><B><I>From:</I></B></td></tr>
<tr>
<td align=center>Month</td>
<td align=center>Day</td>
<td align=center>Year</td>
<td align=center>Hour</td>
<td align=center>Min</td>
<td align=center>Sec</td>
</tr>
<tr><td align=center><select name="f_month">
<option value="1"<? if (date("n", $min_stamp)==1) { echo " selected"; } ?>>Jan</option>
<option value="2"<? if (date("n", $min_stamp)==2) { echo " selected"; } ?>>Feb</option>
<option value="3"<? if (date("n", $min_stamp)==3) { echo " selected"; } ?>>Mar</option>
<option value="4"<? if (date("n", $min_stamp)==4) { echo " selected"; } ?>>Apr</option>
<option value="5"<? if (date("n", $min_stamp)==5) { echo " selected"; } ?>>May</option>
<option value="6"<? if (date("n", $min_stamp)==6) { echo " selected"; } ?>>Jun</option>
<option value="7"<? if (date("n", $min_stamp)==7) { echo " selected"; } ?>>Jul</option>
<option value="8"<? if (date("n", $min_stamp)==8) { echo " selected"; } ?>>Aug</option>
<option value="9"<? if (date("n", $min_stamp)==9) { echo " selected"; } ?>>Sep</option>
<option value="10"<? if (date("n", $min_stamp)==10) { echo " selected"; } ?>>Oct</option>
<option value="11"<? if (date("n", $min_stamp)==11) { echo " selected"; } ?>>Nov</option>
<option value="12"<? if (date("n", $min_stamp)==12) { echo " selected"; } ?>>Dec</option>
</select></td>
<td align=center><input type=text name="f_day" size=2 maxlength=2 value="<? echo date("j", $min_stamp); ?>"></td>
<td align=center><input type=text name="f_year" size=4 maxlength=4 value="<? echo date("Y", $min_stamp); ?>"></td>
<td align=center><input type=text name="f_hour" size=2 maxlength=2 value="<? echo date("G", $min_stamp); ?>"></td>
<td align=center><input type=text name="f_min" size=2 maxlength=2 value="<? echo date("i", $min_stamp); ?>"></td>
<td align=center><input type=text name="f_sec" size=2 maxlength=2 value="<? echo date("s", $min_stamp); ?>"></td>
</tr>
</table>
</td>
<td bgcolor=#000000><img src="1x1.gif" width=1></td>
<td align=center>
<table border=0 cellpadding=0>
<tr><td align=center colspan=6><B><I>To:</I></B></td></tr>
<tr>
<td align=center>Month</td>
<td align=center>Day</td>
<td align=center>Year</td>
<td align=center>Hour</td>
<td align=center>Min</td>
<td align=center>Sec</td>
</tr>
<tr><td align=center><select name="t_month">
<option value="1"<? if (date("n", $max_stamp)==1) { echo " selected"; } ?>>Jan</option>
<option value="2"<? if (date("n", $max_stamp)==2) { echo " selected"; } ?>>Feb</option>
<option value="3"<? if (date("n", $max_stamp)==3) { echo " selected"; } ?>>Mar</option>
<option value="4"<? if (date("n", $max_stamp)==4) { echo " selected"; } ?>>Apr</option>
<option value="5"<? if (date("n", $max_stamp)==5) { echo " selected"; } ?>>May</option>
<option value="6"<? if (date("n", $max_stamp)==6) { echo " selected"; } ?>>Jun</option>
<option value="7"<? if (date("n", $max_stamp)==7) { echo " selected"; } ?>>Jul</option>
<option value="8"<? if (date("n", $max_stamp)==8) { echo " selected"; } ?>>Aug</option>
<option value="9"<? if (date("n", $max_stamp)==9) { echo " selected"; } ?>>Sep</option>
<option value="10"<? if (date("n", $max_stamp)==10) { echo " selected"; } ?>>Oct</option>
<option value="11"<? if (date("n", $max_stamp)==11) { echo " selected"; } ?>>Nov</option>
<option value="12"<? if (date("n", $max_stamp)==12) { echo " selected"; } ?>>Dec</option>
</select></td>
<td align=center><input type=text name="t_day" size=2 maxlength=2 value="<? echo date("j", $max_stamp); ?>"></td>
<td align=center><input type=text name="t_year" size=4 maxlength=4 value="<? echo date("Y", $max_stamp); ?>"></td>
<td align=center><input type=text name="t_hour" size=2 maxlength=2 value="<? echo date("G", $max_stamp); ?>"></td>
<td align=center><input type=text name="t_min" size=2 maxlength=2 value="<? echo date("i", $max_stamp); ?>"></td>
<td align=center><input type=text name="t_sec" size=2 maxlength=2 value="<? echo date("s", $max_stamp); ?>"></td>
</tr>
</table>
</td></tr>
</table>
<P>
Summarize/average the data in
<input type=text name="summ_interval" size=6 value="1"> -
<select name="summ_units">
  <option value="second">second</option>
  <option value="minute">minute</option>
  <option value="hour" selected>hour</option>
  <option value="day">day</option>
  <option value="month">month</option>
  <option value="year">year</option>
</select>
chunks when making the text-only report.<BR>
</P>
<P>
<hr size=1 noshade>
<B>Graph Configuration</B><P>
Make the graphs
<input type=text name="graph_x" size=5 value="<? echo $X; ?>">
pixels wide by
<input type=text name="graph_y" size=5 value="<? echo $Y; ?>">
pixels high.<BR>

<table border=0 cellpadding=1 cellspacing=3>
<tr><td colspan=13 bgcolor=#000000><img src="1x1.gif" height=1></td></tr>
<tr><td colspan=13 align=center>Set colors to use on the graphs below
(standard RGB hex color codes).</td></tr>
<tr><td colspan=13 bgcolor=#000000><img src="1x1.gif" height=1></td></tr>
<tr>
<td align=center>Background</td>
<td rowspan=3 bgcolor=#000000><img src="1x1.gif" height=1></td>
<td align=center>Text</td>
<td rowspan=3 bgcolor=#000000><img src="1x1.gif" height=1></td>
<td align=center>Light Border</td>
<td rowspan=3 bgcolor=#000000><img src="1x1.gif" height=1></td>
<td align=center>Dark Border</td>
<td rowspan=3 bgcolor=#000000><img src="1x1.gif" height=1></td>
<td align=center>Peak</td>
<td rowspan=3 bgcolor=#000000><img src="1x1.gif" height=1></td>
<td align=center>Incoming</td>
<td rowspan=3 bgcolor=#000000><img src="1x1.gif" height=1></td>
<td align=center>Outgoing</td>
</tr>
<tr>
<td align=center><input onChange="colorswitch('g_bg');" type=text size=7 maxlength=6
 name="g_bg" value="<? echo strtoupper($graph_background); ?>"></td>
<td align=center><input onChange="colorswitch('g_text');" type=text size=7 maxlength=6
 name="g_text" value="<? echo strtoupper($graph_text); ?>"></td>
<td align=center><input onChange="colorswitch('g_lborder');" type=text size=7 maxlength=6
 name="g_lborder" value="<? echo strtoupper($graph_border_light); ?>"></td>
<td align=center><input onChange="colorswitch('g_dborder');" type=text size=7 maxlength=6
 name="g_dborder" value="<? echo strtoupper($graph_border_dark); ?>"></td>
<td align=center><input onChange="colorswitch('g_peak');" type=text size=7 maxlength=6
 name="g_peak" value="<? echo strtoupper($graph_peak_highlight); ?>"></td>
<td align=center><input onChange="colorswitch('g_in');" type=text size=7 maxlength=6
 name="g_in" value="<? echo strtoupper($graph_incoming_data); ?>"></td>
<td align=center><input onChange="colorswitch('g_out');" type=text size=7 maxlength=6
 name="g_out" value="<? echo strtoupper($graph_outgoing_data); ?>"></td>
</tr>
<tr>
<td class="g_bg" align=center bgcolor=#<? echo $graph_background; ?>>
<script language="Javascript">
if (incapable) { document.write('<font color=#<? echo $graph_text; ?>>'); }
</script>
Sample Text</td>
<td class="g_text" align=center bgcolor=#<? echo $graph_background; ?>>
<script language="Javascript">
if (incapable) { document.write('<font color=#<? echo $graph_text; ?>>'); }
</script>
Sample Text</td>
<td class="g_lborder" align=center bgcolor=#<? echo $graph_background; ?>>
<script language="Javascript">
if (incapable) { document.write('<font color=#<? echo $graph_border_light; ?>>'); }
</script>
Sample Text</td>
<td class="g_dborder" align=center bgcolor=#<? echo $graph_background; ?>>
<script language="Javascript">
if (incapable) { document.write('<font color=#<? echo $graph_border_dark; ?>>'); }
</script>
Sample Text</td>
<td class="g_peak" align=center bgcolor=#<? echo $graph_background; ?>>
<script language="Javascript">
if (incapable) { document.write('<font color=#<? echo $graph_peak_highlight; ?>>'); }
</script>
Sample Text</td>
<td class="g_in" align=center bgcolor=#<? echo $graph_background; ?>>
<script language="Javascript">
if (incapable) { document.write('<font color=#<? echo $graph_incoming_data; ?>>'); }
</script>
Sample Text</td>
<td class="g_out" align=center bgcolor=#<? echo $graph_background; ?>>
<script language="Javascript">
if (incapable) { document.write('<font color=#<? echo $graph_outgoing_data; ?>>'); }
</script>
Sample Text</td>
</tr>
<tr><td colspan=13 bgcolor=#000000><img src="1x1.gif" height=1></td></tr>
</table>

<hr size=1 noshade>
<table border=0>
<tr>
<td colspan=2>Save this report as <input type=text name="rpt_name" size=30></td>
</tr>
<tr><td align=left>
<input type=submit value=" Run It! ">
</td><td align=right>
<input type=reset value=" Clear "> the form.
</td>
</tr>
</table>
</P>
</form>
</body>
</html>
