<?
/*
 Network Interface Statistics Collection Agent v2.5
 by Brett Baugh

 This page just presents a list of the earliest/latest times stats were
 collected on every host, to help when setting report options. Cheezy and simple.

 */

set_time_limit(0);
require_once("/etc/nisca/nisca.conf");
require_once($location["functions"]);
$random_msgs="";
?>
<html><head>
<style type="text/css">
  * {
        font-family: <? echo $fontface; ?>;
        font-size: medium;
    } 
</style>
<title>NISCA Collection Times Report</title>
</head>
<? echo default_body() . titlebar(); ?>
<P><hr noshade size=1>
This is every host for which collected statistics exist in the database.
It doesn't list the hosts <I>currently</I> being monitored, only which <I>have been</I> monitored.
It tells you the valid date/time range you can use when getting reports from a certain host.
If you don't see a host listed here, there are no statistics for it in the database.
Click on a hostname to see more-detailed info (<I>i.e.</I>, the time range detail for each
interface on that host).
<P>
Please wait; this could take awhile...
<P>
<a href="index.php">Back To The Menu</a>
<P>
<?
flush();
$sq="select id, hostname, if_name from stats_ifs order by hostname, if_name";
$res=dosql($sq);
if (mysql_num_rows($res) < 1) {
  echo "No statistics have been collected.<P>\n";
  echo "<P>\n<a href=\"index.php\">Back To The Menu</a>\n</body></html>";
  die;
}
echo "<table border=1 cellpadding=3 cellspacing=0>\n<tr><th>Hostname</th>\n".
     "<th>First Timestamp</th>\n<th>Last Timestamp</th></tr>\n";

$sqladds = array();
$prevhost = "";
while ($row=mysql_fetch_array($res)) {
  if ($prevhost != "" && $row["hostname"] != $prevhost) {
    $ifadd=substr($ifadd, 0, strlen($ifadd) -4);
    $sqladds[$prevhost] = $ifadd;
    $ifadd="";
  }
  $prevhost=$row["hostname"];
  $ifadd .= "if_id={$row["id"]} OR ";
}
if ($ifadd != "") {
  $ifadd=substr($ifadd, 0, strlen($ifadd) -4);
  $sqladds[$prevhost] = $ifadd;
}

// Yes, using "limit" is faster than the MySQL min()/max() functions. I checked. Go figure.
for (reset($sqladds); $k=key($sqladds); next($sqladds)) {
  $res2 = dosql("select stamp from stats where ({$sqladds[$k]}) order by stamp limit 1");
  $res3 = dosql("select stamp from stats where ({$sqladds[$k]}) order by stamp desc limit 1");
  $low=mysql_result($res2, 0, 0);
  $high=mysql_result($res3, 0, 0);
  if ($low=="" || $high=="") { continue; }
  echo "<tr><td align=right>$font2<a href=\"ranges2.php?h=" .
       urlencode($k) . "\">$k</a></td>\n" .
       "<td>$font2" . date($dateformat, $low) . "</td>\n".
       "<td>$font2" . date($dateformat, $high) . "</td></tr>\n";
}
?>
</table>
<P><hr noshade size=1>
<a href="index.php">Back To The Menu</a>
</body></html>
