<?
/*
 Network Interface Statistics Collection Agent v2.5
 by Brett Baugh

 This page just presents a list of the earliest/latest times stats were
 collected on every interface, to help when setting report options. Cheezy and simple.

 */

if (trim($h)=="") {
  header("Location: ranges1.php");
  die;
}

set_time_limit(0);
require_once("/etc/nisca/nisca.conf");
require_once($location["functions"]);
?>
<html><head>
<style type="text/css">
  * {
        font-family: <? echo $fontface; ?>;
        font-size: medium;
    } 
</style>
<title>NISCA Collection Times Report (<? echo $h; ?>)</title>
</head>
<? echo default_body() . titlebar(); ?>
<P><hr noshade size=1>
This is every interface on <B>"<? echo $h; ?>"</B> for which collected statistics exist in the database.
It doesn't list what's <I>currently</I> being monitored, only what <I>has been</I> monitored.
It tells you the valid date/time range you can use when getting reports on a certain interface.
If you don't see an interface listed here, there are no statistics for it in the database.
<P>
Please wait; this could take awhile...
<P>
<a href="index.php">Back To The Menu</a>
<P>
<?
$sq="select id, if_name from stats_ifs where hostname='$h' order by if_name";
$res=dosql($sq);
if (mysql_num_rows($res) < 1) {
  echo "No statistics have been collected for the host <B>\"$h\"</B>. " .
       "This shouldn't happen; stop manually typing URLs. <tt>:)</tt><P>\n";
  echo "<P>\n<a href=\"index.php\">Back To The Menu</a>\n</body></html>";
  die;
}
flush();
echo "<table border=1 cellpadding=3 cellspacing=0>\n<tr><th>$font2"."Interface</th>\n".
     "<th>$font2"."First Timestamp</th>\n<th>$font2"."Last Timestamp</th></tr>\n";
while ($row=mysql_fetch_array($res)) {
// Yes, using "limit" is faster than the min()/max() functions. Go figure.
  $sq2="select stamp from stats where if_id={$row["id"]} order by stamp limit 1";
  $sq3="select stamp from stats where if_id={$row["id"]} order by stamp desc limit 1";
  $res2=dosql($sq2);
  $res3=dosql($sq3);
  $low=mysql_result($res2, 0, 0);
  $high=mysql_result($res3, 0, 0);
  if ($low=="" || $high=="") { continue; }
  echo "<tr><td align=right>$font2{$row["if_name"]}</td>\n" .
       "<td>$font2" . date($dateformat, $low) . "</td>\n".
       "<td>$font2" . date($dateformat, $high) . "</td></tr>\n";
}
?>
</table>
<P><hr noshade size=1>
<a href="index.php">Back To The Menu</a>
</body></html>
